"""
Goodrich et al
Data Structures in Python
Chapter 5: Array-Based Sequences

Demonstrate the amortized cost of resizing when append happens.

Much to learn: https://docs.python.org/3/library/string.html#formatstrings
"""

from time import time, clock

def compute_average(n):
    data = []
    start = time()
    startc = clock()
    for k in range(n):
        data.append(None)
    end = time()
    endc = clock()
    return (end-start)/n
    #return ((end-start)/n, (endc-startc)/n)

if __name__=="__main__":
    values = [int(10**j) for j in range(1,8)]
    for n in values:
        INV_MICROSEC = 10**6
        t = compute_average(n)*INV_MICROSEC
        print("n: {0:10d}\tmicrosec: {1:.3f}".format(n,t))


