"""
Goodrich et al
Data Structures in Python
Chapter 5: Array-Based Sequences

Question C-5.26 

Let B be an array of size n >= 6
and containing integers from 1 to n-5,
inclusive, with 5 repeated integers.

Describe a good algorithm
for finding the 5 integers in B 
that are repeated.
"""

def five_dupes(arr):
    n = len(arr)

    # Keeping track of the counts is a bit tricky.
    # If there are 5 repeats, we take out 5 slots.
    # But we are starting at 1, so we put 1 slot back in
    # to account for zero, instead of doing tricky integer math.
    counts = [0]*((n-5)+1)

    dupecounter = 0
    dupeindex = []
    for i,k in enumerate(arr):
        if(counts[k]>0):
            dupecounter += 1
            dupeindex.append(i)
            if(dupecounter>5):
                print("Found more than 5 dupes.")
        counts[k] += 1
    return dupeindex

if __name__=="__main__":
    mylist = [5,4,3,2,1,4,6,4,7,4,8,4,4]
    print("Indices of 5 duplicates:")
    print(five_dupes(mylist))
